# -*- coding: utf-8 -*-
# This file has been generated, if you wish to
# modify it in a permanent way, please refer
# to the script file : gen/generator_python.rb

import heapq
from collections import defaultdict
from api import *


dist = lambda p: lambda q: distance(p, q)


signe = lambda x: 1 if x == 0 else int(x/abs(x))
mul = lambda a, p: (int(a[0]*p[0]), int(a[1]*p[1]))
add = lambda p, q: (p[0] + q[0], p[1] + q[1])
mini = lambda p, q: (min(p[0], q[0]), min(p[1], q[1]))


def delta(p, q):
    """Renvoie la valeur absolue du delta et son signe."""
    delt = add(q, mul((-1, -1), p))
    return (abs(delt[0]), abs(delt[1])), (signe(delt[0]), signe(delt[1]))


def bouger(p, q):
    """Se deplace jusqu'a la cible, ou s'en rapprocher le + possible."""

    delt, s = delta(p, q)
    d = points_deplacement()
    arrivee = add(p, mul(s, mini((d//2, (d+1)//2), delt)))
    deplacer(arrivee)


class QTNode:
    """Quad tree rudimentaire..."""

    __slots__ = ('ne', 'nw', 'se', 'sw', 'pos', 'parent')
    def __init__(self, pos, ne, nw, se, sw, parent):
        self.pos = pos
        self.ne = ne
        self.nw = nw
        self.se = se
        self.sw = sw
        self.parent = parent

    def get(self, c):
        coord, size = self.pos

        if size == 0:
            return self.val
        rel = (c[0]-coord[0], c[1]-coord[1])

        if min(rel) < 0 or max(rel) >= size:
            return self.parent.get(c)

        if rel[0] < size:
            if rel[1] < size:
                return self.nw if cond else self.nw.get(c)
            else:
                return self.sw if cond else self.sw.get(c)
        else:
            if rel[1] < size:
                return self.ne if cond else self.ne.get(c)
            else:
                return self.se if cond else self.se.get(c)



class G:
    """classe des variables globales (pour eviter global a chaque modif)"""

    moi, lui = 0, 0  # IDs
    portails = []  # listes des portails
    adjacences = {}  # distances entre tt couple (frozenset) de portails
    # set des portails accessibles (eventuellement avec des turbos) pour tt
    # portail
    proches = defaultdict(set)

    importances = defaultdict(int)



def to_qtree(tbl):
    if len(tbl) == 1:
        return tbl[0][0]
    else:
        return [[QTNode()]]

def partie_init():
    G.moi = moi()
    G.lui = adversaire()

    G.portails = liste_portails()
    tbl = [[0]*32 for _ in range(32)]
    for (x, y) in G.portails:
        tbl[x][y] = True

    for 


    for i in range(len(G.portails)-1):
        for j in range(i+1, len(G.portails)):
            p, q = G.portails[i], G.portails[j]
            d = distance(p, q)

            G.adjacences[frozenset({p, q})] = d
            if d < 15:
                G.proches[p].add(q)
                G.proches[q].add(p)
    print("Initialisation OK!")


def portail_proche(p):
    pass


def lier_max(pos):
    for cible in G.portails:
        if len(liens_incidents_portail(cible)) > 5:
            continue
        lier(cible)

def jouer_tour():
    """
    pos = position_agent(G.moi)
    while points_deplacement():
        if not pos in G.portails:
            plus_proche = min(
                    (p for p in G.portails if not portail_joueur(p) == G.moi),
                     key=dist(pos))
        bouger(pos, plus_proche)
        pos = plus_proche
        neutraliser()
        capturer()
        lier_max(pos)"""
    pass

def partie_fin():
    if score(G.moi) > score(G.lui):
        print("Lol t'as perduuuu!!! 42")
    elif score(G.moi) == score(G.lui):
        print("Pas trop mal, je voulais te tester...")
    else:
        print("Ma revenche sera terrible! >:O")

